#include "SimpleTypeSystem.h"
#include "test_macros.h"
#include <stdlib.h>
#include <stdint.h>
#include <time.h>

void
for_each_print_map (SLinkedList * self, SMapItem * item, sint * itt) {
  s_print ("Key: \"%s\" Value: %ld on iteration: %d\n", (schar *)item->key,
                                                       (slong)item->value,
                                                       (*itt));
  (*itt)++;
}

int test_map (void) {
  setup_unit ();
  
  SMap * map = NULL;
  map =  s_map_new (COMPFUNC (s_string_is_equal),
                    HASH_FUNC (s_hash),
                    NULL,
                    NULL);
  
  test_case (map != NULL, "Map is not null.");
  
  s_map_add (map, "Hello", (spointer)(sint) 1337);
  
  test_case (((sint)(slong) s_map_get (map, "Hello") == (sint) 1337),
                                                  "The got value is the"
                                                  " same as the one added to"
                                                  " the map");
  SMapItem * item = s_map_get_item (map, "Hello");
  s_print ("The key was: %s, the Value was: %ld\n", (schar *) item->key,
                                                   (slong) item->value);
  
  s_print (S_COLOR_BLUE "Replacing value with a new one\n");
  
  s_map_add (map, "Hello", (spointer)(sint) 1338);
  test_case (((sint)(slong) s_map_get (map, "Hello") == (sint) 1338), "The got value is the"
                                                  " same as the one added to"
                                                  " the map");
  
  s_map_free (map, TRUE);
  
  end_unit ();
}
